#!<WEB_PERL>

require "<SERVER_CGI_LIB>"; 
$| = 1;

$SERVER_VAR  = "<SERVER_VAR>";
&ReadParse();
$SUFFIX = ".out";

$JobID    = $in{'JobID'};
$pass     = $in{'pass'};
$suff     = $in{'suff'};
$bottom   = $in{'Bottom'};

if ($suff =~ /Final/) {
    $SUFFIX = ".results";
}
if ($suff =~ /Queues/) {
    &DisplayQueues();
} else {

    if (&CheckPwd()){    
	&CorrectPwd();
    }
    else {
	&WrongPwd();
    }
}


sub CheckPwd{

    $job_password_file = "<SERVER_VAR>"."/jobs/job.".$JobID."/job.password";

    open(PASSWD, "$job_password_file");  
    @lines = <PASSWD>;
    chomp($job_password = $lines[0]);
    close(PASSWD);     

    if ($job_password eq $in{'pass'}){
	$return_flag = 1;
    }				
    else {
	$return_flag = 0;
    }

    $return_flag;
}


sub CorrectPwd{

print <<END;
Content-type: text/html

<HEADER>
<TITLE>Job Status <SERVER_NAME></TITLE>
<base href='<BASE_HREF>'
</HEADER>
<BODY BGCOLOR>
<center>
<a href=""><img src='images/globe_small.jpg' alt="NEOS Server Home" border=0></a>
<p><br><br><br>
<script language="JavaScript">
function scrollDown() {
    var whence = 1000000000
    self.scroll(1,whence)
}
function scrollUp() {
    var whence = 1
    self.scroll(1,whence)
}
</script>
<form method=POST action="<SERVER_CGI_URL>/check-pwd.cgi">

<input type=hidden name="JobID" value="$JobID">
<input type=hidden type=password name="pass" value="$pass">
<input type=submit name="Top" value="Refresh Results">
<input type=button name="Bottom" value="Jump to End" onClick=scrollDown()>
<p>
</center>
<b>Results</b>
<br><br>

<PRE>
END

open (OUT, "$SERVER_VAR/jobs/job.$JobID/job$SUFFIX") or print "Could not find your output file job.$JobID/job$SUFFIX";
while(<OUT>) {
	print;
}
close OUT;

print "</PRE>\n";
print <<END;
<center>
<input type=submit name="Bottom" value="Refresh Results">
<input type=button name="Top" value="Jump to Top" onClick=scrollUp()>
</center>
<input type=hidden name=suff value="$suff">
END
if(defined($bottom) and (length($bottom)>0)) {
print <<NED;
<script language="JavaScript">
scroll(1,1000000000)
</script>
NED
}
print <<END;
</BODY></HTML>
END


}

sub WrongPwd{

print <<END;
Content-type: text/html

<HEADER>
<TITLE>Job Status <SERVER_NAME></TITLE>
<base href='<BASE_HREF>'
</HEADER>
<BODY BGCOLOR>
<center>
<a href=""><img src='images/globe_small.jpg' alt="NEOS Server Home" border=0></a>

<p><br><br><br>

<form method=POST action="<SERVER_CGI_URL>/check-pwd.cgi?$JobID">

<b>Wrong password</b>

<table><tr><td>
Enter the job number :</td><td align=right>
<input type=text name="JobID" value="$JobID" size=15>
<p></td></tr>
<tr><td>
Enter the password for job $JobID:</td><td align=right>
<input type=password name="pass" size=10>
</td></tr></table>
 <br><br>
<input type=submit name="suff" value="View Final Results">
<br>
<input type=submit name="suff" value="View Intermediate Results">

</form>
<br><br>
</center>
<center>
<a href=""><img src='images/neos_home.jpg' alt="NEOS Server Home" border=0></a>
</center>
</BODY>
END

}

sub DisplayQueues {
    $queues = "Queues file could not be read.\n";
    if(open(Q, "<SERVER_VAR>/logs/queues")) {
	@queues = <Q>;
	$queues = join '<p>', @queues;
    }
print <<END;
Content-type: text/html

<HEADER>
<TITLE>Job Status <SERVER_NAME></TITLE>
<base href='<BASE_HREF>'
</HEADER>
<BODY BGCOLOR>
<center>
<a href=""><img src='images/globe_small.jpg' alt="NEOS Server Home" border=0></a>
</center>

<p><br><br><br>
$queues
<p>
<br><br>
<center>
<a href=""><img src='images/neos_home.jpg' alt="NEOS Server Home" border=0></a>
</center>

</BODY>
END

}
